import { DomainEvent, DomainEventProps } from '@libs/ddd';

export class AdCreatedDomainEvent extends DomainEvent {
  readonly userId: string;
  readonly driver: boolean;
  readonly passenger: boolean;
  readonly frequency: string;
  readonly fromDate: string;
  readonly toDate: string;
  readonly monTime: string;
  readonly tueTime: string;
  readonly wedTime: string;
  readonly thuTime: string;
  readonly friTime: string;
  readonly satTime: string;
  readonly sunTime: string;
  readonly monMarginDuration: number;
  readonly tueMarginDuration: number;
  readonly wedMarginDuration: number;
  readonly thuMarginDuration: number;
  readonly friMarginDuration: number;
  readonly satMarginDuration: number;
  readonly sunMarginDuration: number;
  readonly seatsProposed: number;
  readonly seatsRequested: number;
  readonly strict: boolean;
  readonly waypoints: Waypoint[];

  constructor(props: DomainEventProps<AdCreatedDomainEvent>) {
    super(props);
    this.userId = props.userId;
    this.driver = props.driver;
    this.passenger = props.passenger;
    this.frequency = props.frequency;
    this.fromDate = props.fromDate;
    this.toDate = props.toDate;
    this.monTime = props.monTime;
    this.tueTime = props.tueTime;
    this.wedTime = props.wedTime;
    this.thuTime = props.thuTime;
    this.friTime = props.friTime;
    this.satTime = props.satTime;
    this.sunTime = props.sunTime;
    this.monMarginDuration = props.monMarginDuration;
    this.tueMarginDuration = props.tueMarginDuration;
    this.wedMarginDuration = props.wedMarginDuration;
    this.thuMarginDuration = props.thuMarginDuration;
    this.friMarginDuration = props.friMarginDuration;
    this.satMarginDuration = props.satMarginDuration;
    this.sunMarginDuration = props.sunMarginDuration;
    this.seatsProposed = props.seatsProposed;
    this.seatsRequested = props.seatsRequested;
    this.strict = props.strict;
    this.waypoints = props.waypoints;
  }
}

export class Waypoint {
  position: number;
  name?: string;
  houseNumber?: string;
  street?: string;
  locality?: string;
  postalCode?: string;
  country: string;
  lon: number;
  lat: number;
}
