import { ValueObject } from '@libs/ddd';
import { AddressProps } from './address.value-object';

/** Note:
 * Value Objects with multiple properties can contain
 * other Value Objects inside if needed.
 * */

export interface WaypointProps {
  position: number;
  address: AddressProps;
}

export class Waypoint extends ValueObject<WaypointProps> {
  get position(): number {
    return this.props.position;
  }

  get address(): AddressProps {
    return this.props.address;
  }

  // eslint-disable-next-line @typescript-eslint/no-unused-vars
  protected validate(props: WaypointProps): void {
    return;
  }
}
