import { WaypointDto } from '../waypoint.dto';

export const hasValidPositionIndexes = (waypoints: WaypointDto[]): boolean => {
  if (!waypoints) return false;
  if (waypoints.length == 0) return false;
  if (waypoints.every((waypoint) => waypoint.position === undefined))
    return false;
  if (waypoints.every((waypoint) => typeof waypoint.position === 'number')) {
    const positions = Array.from(waypoints, (waypoint) => waypoint.position);
    positions.sort();
    for (let i = 1; i < positions.length; i++)
      if (positions[i] != positions[i - 1] + 1) return false;

    return true;
  }
  return false;
};
